
/* safety airbag */

int_T airbag(real_T *u, real_T *pos, real_T *vel, int_T imode, SimStruct *S)
{
/***********************************************************************/
/* BE CAREFUL NOT TO CHANGE THE FOLLOWING CODE (SOFTWARE SAFETY LAYER) */
/***********************************************************************/

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	int_T i,ibag;

	ibag=0;

	if (imode==0) {

/*	  check for boundary tresspassing */

	  for (i=0;i<4;i++) {
	    if (iaxis(i)==1) {
	      if (pos[i]<=minpos(i)+margin(i)) {
	        ibag=(int_T) bag(i);
	      }
	      if (pos[i]>=maxpos(i)-margin(i)) {
	        ibag=(int_T) bag(i);
	      }
	    }
	  }

	  return ibag;

	} else {

	  for (i=0;i<4;i++) {
	    if (iaxis(i)==1) {
	      u[i]=0.0;
	      if (pos[i]<=minpos(i)+margin(i)) {
	        u[i]=p_airbag(i)*(minpos(i)+margin(i)-pos[i])-d_airbag(i)*vel[i];
	      }
	      if (pos[i]>=maxpos(i)-margin(i)) {
	        u[i]=p_airbag(i)*(maxpos(i)-margin(i)-pos[i])-d_airbag(i)*vel[i];
	      }
	    }
	  }

	  return 1;

	}

/*************************************************************************/
/*************************************************************************/
}
