
/* send motor commands */

#define KSCALE1	0.4
#define KSCALE2	0.4
#define KSCALE3	0.25
#define KSCALE4	0.25

int_T send_motor_command(real_T *u, SimStruct *S)
{
	int_T i,iclip;

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	int_T ilink;

	ilink = (int_T) (*(mxGetPr(LINK_ID)));

/*	clip motor command if higher than maxout */

	iclip=1;

/*	scale inputs */
	u[0]=KSCALE1*u[0];
	u[1]=KSCALE2*u[1];
	u[2]=KSCALE3*u[2];
	u[3]=KSCALE4*u[3];

	for (i=0;i<4;i++) {
	  if (fabs(u[i])>maxout(i)) {
	    u[i]=maxout(i)*u[i]/fabs(u[i]);
	    iclip=(int_T) clip(i);
	  }
	  u[i]=iaxis(i)*u[i];
	}

#ifndef MATLAB_MEX_FILE
	ec_EL4038_dac_write_chan(-u[0], 0, ilink);
	ec_EL4038_dac_write_chan( u[1], 1, ilink);
	ec_EL4038_dac_write_chan( u[2], 2, ilink);
	ec_EL4038_dac_write_chan(-u[3], 3, ilink);
#endif

	return iclip;
}
